<?php
	// If this file is called directly, abort.
	if (!defined('WPINC')) {
		die;
	}
?>
<!-- This file is used to markup the administration form of the widget. -->

<!-- Custom  Title Field -->
<p>
    <label for="<?php echo $this->get_field_id('title'); ?>"><?php esc_html_e('Title', "cbxpoll"); ?></label>

    <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>"
           name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>"/>
</p>
<p>
	<?php
		$poll_display_methods = cbxpollHelper::cbxpoll_display_options();

	?>
    <label for="<?php echo $this->get_field_id('chart_type'); ?>"><?php esc_html_e('Chart Type', "cbxpoll"); ?></label>
    <select class="widefat" id="<?php echo $this->get_field_id('chart_type'); ?>"
            name="<?php echo $this->get_field_name('chart_type'); ?>">
		<?php
			foreach ($poll_display_methods as $key => $method) {
				echo '<option value="' . $key . '" ' . selected($chart_type, $key, false) . '>' . $method['title'] . '</option>';
			}
		?>
    </select>
</p>
<p>
    <label for="<?php echo $this->get_field_id('poll_id'); ?>"><?php esc_html_e('Select Poll', "cbxpoll"); ?></label>
    <select class="widefat" id="<?php echo $this->get_field_id('poll_id'); ?>"
            name="<?php echo $this->get_field_name('poll_id'); ?>">
		<?php
			$args = array(
				'post_type'      => 'cbxpoll',
				'orderby'        => 'ID',
				'order'          => 'DESC',
				'post_status'    => 'publish',
				'posts_per_page' => -1,
			);

			$posts_array = get_posts( $args );


			if (sizeof($posts_array) > 0) :
				foreach ( $posts_array as $post ) : CBXPollHelper::setup_admin_postdata( $post );
					$post_id = get_the_ID();
					echo '<option value="' . $post_id . '" ' . selected($post_id, $poll_id, false) . '>' . sprintf(__('Poll ID: %d - %s', 'cbxpoll'), $post_id, get_the_title()) . '</a></option>';
				endforeach;
				CBXPollHelper::wp_reset_admin_postdata();
			endif;



		?>
    </select>
</p>
<p>
    <label for="<?php echo $this->get_field_id('description'); ?>"><?php esc_html_e('Show Poll description', "cbxpoll"); ?></label>
    <select class="widefat" id="<?php echo $this->get_field_id('description'); ?>"
            name="<?php echo $this->get_field_name('description'); ?>">
        <option <?php selected($description, '1', true); ?> value="1"><?php esc_html_e('Yes', 'cbxpoll') ?></option>
        <option <?php selected($description, '0', true); ?> value="0"><?php esc_html_e('No', 'cbxpoll') ?></option>
    </select>
</p>
<input type="hidden" id="<?php echo $this->get_field_id('submit'); ?>"
       name="<?php echo $this->get_field_name('submit'); ?>" value="1"/>
<?php
	do_action('cbxpollsinglewidget_form_admin', $instance, $this);